/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    RevHead                                                   *
*Project Version: 4.3.0                                                     *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Tuesday 16th April 2013                                   *
*                                                                           *
*Start DateStamp: 15-Sep-2008 11.16.15 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:  http://balean.net/linprogs                                          *
*                                                                           *
*Project Summary:                                                           *
* Create/maintain programming file revision headers and history             *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       complain.h                                                *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       10-Apr-2013 18.37.30 -36000 0                             *
*                                                                           *
*File Summary:                                                              *
* Header file for complain.cpp                                              *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef _COMPLAIN_H
#define _COMPLAIN_H

#include "revhead.h"

enum
    {
    CN_ABORT,
    CN_CONTINUE,
    CN_OK, CN_CANCEL,
    CN_OK_CANCEL,
    CN_OK_ABORT, 
    CN_RETRY_ABORT,
    CN_RETRY_CANCEL,
    CN_YES_NO
    }; 

class Complain
{
public:
  Complain(void);
  Complain(GdkPixbuf *img);
  Complain(GdkPixbuf *pixbuf, 
                    GdkRGBA *bg_normal, GdkRGBA *bg_prelight,
                    const gchar *cancel_stock_id, const gchar *ok_stock_id);

  ~Complain(void);

  void complain (int n, char *title, char *msg, 
                      void (*YesFunc)(GtkWidget *widget, Complain *c), 
                      void (*NoFunc)(GtkWidget *widget, Complain *c),
                      gpointer d );

  static void end_complain(GtkWidget *widget, Complain *c);
  static void clear_complain(GtkWidget *widget, Complain *c);

  gpointer data;
  
private:
  void initialize(GdkPixbuf *pixbuf, 
                    GdkRGBA *bg_normal, GdkRGBA *bg_prelight,
                    const gchar *cancel_stock_id, const gchar *ok_stock_id);
	
  //void decorate_button(GtkWidget *widget,
  //                      GdkColor *bg_normal,  GdkColor *bg_prelight, const gchar *stock_id);

  void decorate_widget(GtkWidget *widget,
         GdkRGBA *fg_normal, GdkRGBA *bg_normal,  GdkRGBA *bg_prelight, const gchar *stock_id);

	GtkWidget *dialog_window;
  GdkPixbuf *image_pixbuf;
	
  //GdkColor *bg_normal;
  //GdkColor *bg_prelight;
	GdkRGBA *bg_normal;
	GdkRGBA *bg_prelight;
	
  const gchar *cancel_stock_id;
  const gchar *ok_stock_id;

 protected:

};

#endif // _COMPLAIN_H
