/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    RevHead                                                   *
*Project Version: 4.3.0                                                     *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Tuesday 16th April 2013                                   *
*                                                                           *
*Start DateStamp: 15-Sep-2008 11.16.15 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:  http://balean.net/linprogs                                          *
*                                                                           *
*Project Summary:                                                           *
* Create/maintain programming file revision headers and history             *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       entrylist.cpp                                             *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       15-Apr-2013 20.21.50 -36000 0                             *
*                                                                           *
*File Summary:                                                              *
* This looks after multi-line information such as comments.                 *
* 20-Aug-2004 12.10.29 -36000 0.00    DMB                                   *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#include "entrylist.h"

#include "misc.h"

using namespace misc;
using namespace std;




Witem & Witem::operator= (const Witem & w)
{
widget = w.widget;
s = w.s;  
return *this;
}
  
EntryList::EntryList(void)
{
focus_widget = NULL; // widget with focus
box = NULL;          // list entry box
  
cout << "EntryList:\n";


}

EntryList::~EntryList(void)
{
cout << "~EntryList:\n";
free_witems();
}

// Free the whole entry list
void EntryList::free_witems(void)
{  
list<Witem *>::iterator i;  

for (i=witems.begin(); i!=witems.end(); ++i)
  { 
  delete *i;  
  }

witems.clear();
  
focus_widget = NULL;
}


// Create a new string list from the data in the entrylist
void EntryList::createstringlist(EntryList *elist, list<string> &alist)
{
list<Witem *>::iterator i; 
string s;
alist.clear();


if (! elist)
  {
  cerr << "EntryList::createstringlist - elist is NULL" << endl;
  return;
  }

  
for (i=elist->witems.begin(); i!=elist->witems.end(); ++i)
  {
  s = (char *)gtk_entry_get_text( GTK_ENTRY( (*i)->widget ) );
    
  remove_leading(s);
  remove_trailing(s);

  UNLESS (s.empty()) alist.push_back(s);    

  }

}




// Return TRUE if the list of strings in witems is the same as stringlist
gboolean EntryList::samestrings(list<string> &alist, EntryList *elist)
{
string e;
  
list<Witem *>::iterator wi;
list<string>:: iterator si; 

for (si=alist.begin(), wi=elist->witems.begin();
     ( (si!=alist.end()) && (wi!=elist->witems.end()) );
     ++si, ++wi)
  {  
  e = (char *)gtk_entry_get_text(GTK_ENTRY( (*wi)->widget ) );
  if (e != (*si)) return FALSE;
  }

return (alist.size() ==  elist->witems.size()) ? TRUE : FALSE;
}





// Return TRUE if list contains a string
gboolean EntryList::string_found(EntryList *elist)
{
return( (elist->witems.size()) ? TRUE : FALSE );
}


GtkWidget *EntryList::create_entry_list(void)
{
GtkWidget *wid, *bbox;

free_witems();

GtkWidget *scrolled_window = gtk_scrolled_window_new(NULL, NULL);

GtkWidget *main_box = gtk_box_new(GTK_ORIENTATION_VERTICAL, 2);
gtk_box_set_homogeneous (GTK_BOX (main_box), FALSE);

box = gtk_box_new(GTK_ORIENTATION_VERTICAL, 2);
gtk_box_set_homogeneous (GTK_BOX (box), FALSE);


	
gtk_widget_show(box);

    /* the policy is one of GTK_POLICY AUTOMATIC, or GTK_POLICY_ALWAYS.
     * GTK_POLICY_AUTOMATIC will automatically decide whether you need
     * scrollbars, whereas GTK_POLICY_ALWAYS will always leave the scrollbars
     * there.  The first one is the horizontal scrollbar, the second, 
     * the vertical. */
gtk_scrolled_window_set_policy ( GTK_SCROLLED_WINDOW(scrolled_window),
                                GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC );

gtk_widget_show (scrolled_window);
gtk_box_pack_start(GTK_BOX(main_box), scrolled_window, TRUE, TRUE, 0);
gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_window), box);


// Add buttons here
bbox = gtk_button_box_new(GTK_ORIENTATION_HORIZONTAL);
	
gtk_box_pack_start(GTK_BOX(main_box), bbox, FALSE, FALSE, 0);

 
wid = gtk_button_new_with_label("DELETE LINE");
decorate_widget(wid, &black, NULL, &red, NULL, NULL);
g_signal_connect (G_OBJECT (wid), "clicked",
        G_CALLBACK(deleteline), (gpointer)this);
gtk_box_pack_start(GTK_BOX(bbox), wid, TRUE, TRUE, 0);

wid = gtk_button_new_with_label("PRE-INSERT LINE");
decorate_widget(wid, &black, NULL, &red, NULL, NULL);
g_signal_connect (G_OBJECT (wid), "clicked",
        G_CALLBACK(pre_insert), (gpointer)this);
gtk_box_pack_start(GTK_BOX(bbox), wid, TRUE, TRUE, 0);

wid = gtk_button_new_with_label("POST-INSERT LINE");
decorate_widget(wid, &black, NULL, &red, NULL, NULL);
g_signal_connect (G_OBJECT (wid), "clicked",
        G_CALLBACK(post_insert), (gpointer)this);
gtk_box_pack_start(GTK_BOX(bbox), wid, TRUE, TRUE, 0);
	
wid = gtk_button_new_with_label("APPEND LINE");
decorate_widget(wid, &black, NULL, &red, NULL, NULL);
g_signal_connect (G_OBJECT (wid), "clicked",
        G_CALLBACK(append_empty), (gpointer)this);
gtk_box_pack_start(GTK_BOX(bbox), wid, TRUE, TRUE, 0);

gtk_widget_show_all(main_box);
return main_box;
}




GtkWidget *EntryList::add_to_elist(string s, EntryList *elist)
{
GtkWidget *widget;
Witem *witem = new Witem;

widget= gtk_entry_new();
gtk_entry_set_max_length(GTK_ENTRY(widget), 73);
	
gtk_widget_override_color(GTK_WIDGET(widget), GTK_STATE_FLAG_NORMAL, &black);
gtk_widget_override_color(GTK_WIDGET(widget), GTK_STATE_FLAG_FOCUSED, &red);

witem->s = s;
gtk_entry_set_text(GTK_ENTRY(widget), (char *)s.c_str() );
gtk_widget_show (widget);
  
witem->widget = widget;  

elist->witems.push_back(witem);    

gtk_box_pack_start(GTK_BOX(elist->box), widget, FALSE, FALSE, 0);

g_signal_connect(G_OBJECT(widget),
                    "focus_in_event",
                    G_CALLBACK(in_here),
                    (gpointer)&elist->focus_widget);

g_signal_connect(G_OBJECT(widget),
                    "changed",
                    G_CALLBACK(entry_changed),
                    (gpointer)witem );

//gtk_widget_set_state(widget, GTK_STATE_NORMAL);

gtk_widget_set_state_flags(GTK_WIDGET(widget), GTK_STATE_FLAG_NORMAL, TRUE);

return(widget);
}



void EntryList::entry_changed(GtkWidget *widget, Witem *witem)
{

if (witem)
    {
    witem->s = (char *)gtk_entry_get_text(GTK_ENTRY(widget));
    }
}


void EntryList::in_here(GtkWidget *widget, GdkEvent *event, GtkWidget **focus_widget)
{
*focus_widget = widget;
}


// We need the widget list, the current widget, the string in this widget  
void EntryList::deleteline(GtkWidget *widget, EntryList *elist)
{
//cout << "EntryList::deleteline" << endl;


list<Witem *>::iterator i;

for (i=elist->witems.begin(); i!=elist->witems.end(); ++i)
  {
  if ( (*i)->widget == elist->focus_widget )
    {
    elist->witems.remove(*i);
    gtk_widget_destroy( elist->focus_widget);
    elist->focus_widget = NULL;
    return;    
    }
  }
  
}

// Insert an empty line
// The problem is that it has to be packed into the packbox in order
// This means the old lot has to be removed and a new lot put in...
void EntryList::insertline(GtkWidget *widget, EntryList *elist, gboolean post_insert)
{
list<string> tlist;
int index, i;
int found = 0;
list<Witem *>::iterator wi;
list<string>::iterator si;

// Find the focus widget    
UNLESS (elist->witems.size()) post_insert = FALSE;
  
for (wi=elist->witems.begin(), index=0; wi!=elist->witems.end(); ++wi, ++index)
  {
  if ( (*wi)->widget == elist->focus_widget )
    {
    found = 1;
    break;
    }
  }

if (found && post_insert)
  {
  ++index;
  }
  


// If we have a focus widget or if the list is empty
if (found || (elist->witems.size()==0))
    {
    // GOT IT!
    int numitems = elist->witems.size(); // original size

    // Add a dummy entry at end of the list
    elist->add_to_elist("", elist);

    // Make a copy of the widget strings as they are in tlist up to index
      
      
    // list.insert(p,x) adds x before p but we can't use it here...  
      
    for (wi=elist->witems.begin(), i=0; wi!=elist->witems.end(), i<index; ++wi, ++i)
      {
      tlist.push_back( (*wi)->s );
      }
      
    // Add the empty entry here
    tlist.push_back("");

    
      
    for (; wi!=elist->witems.end(), i<numitems;  ++wi, ++i)
      {
      tlist.push_back( (*wi)->s );
      }
      
      
    elist->focus_widget = NULL;


      
    // Clear out the elist
    for (wi=elist->witems.begin(); wi!=elist->witems.end(); ++wi)
      {
      gtk_widget_destroy(GTK_WIDGET( (*wi)->widget ) ); 
      }
    elist->free_witems();
        

    // Re-write the elist
    
    for (si=tlist.begin(); si!=tlist.end(); ++si)
      {
      elist->add_to_elist((*si), elist);
      }
    }  
} 


void EntryList::pre_insert(GtkWidget *widget, EntryList *elist)
{
insertline(widget, elist, FALSE);
}

void EntryList::post_insert(GtkWidget *widget, EntryList *elist)
{
insertline(widget, elist, TRUE);
}


void EntryList::append_empty(GtkWidget *widget, EntryList *elist)
{
elist->add_to_elist("", elist);
}


/****
void EntryList::display_list(EntryList *elist)
{
list<Witem *>::iterator i;
printf("\n");
for (i=elist->witems.begin(); i!=elist->witems.end(); ++i)
  {
  printf("EntryList::display_list : *i= %08X  : (*i)->widget= %08X : (*i)->s= %s\n", *i, (*i)->widget,((*i)->s).c_str());
  }
}
****/
