/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    RevHead                                                   *
*Project Version: 4.3.0                                                     *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Tuesday 16th April 2013                                   *
*                                                                           *
*Start DateStamp: 15-Sep-2008 11.16.15 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:  http://balean.net/linprogs                                          *
*                                                                           *
*Project Summary:                                                           *
* Create/maintain programming file revision headers and history             *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       entrylist.h                                               *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       11-Apr-2013 09.37.57 -36000 0                             *
*                                                                           *
*File Summary:                                                              *
* Header file for entrylist.cpp                                             *
* 20-Aug-2004 12.10.29 -36000 0.00    DMB                                   *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/
#ifndef _ENTRYLIST_H
#define _ENTRYLIST_H

#include "revhead.h"



class Witem
{
public:
  // return type, operator, operator name, (operand list)
    Witem & operator= (const Witem &w);  // assignment overload
 
    Witem()
        {
          widget = NULL;
        };
            
    GtkWidget *widget;          // entry widget
    string s;
};


    
class EntryList
{
public:
    EntryList(void);
    ~EntryList(void);
  
//    static void display_list(EntryList *elist); // Test the elist...

    GtkWidget *create_entry_list(void);
    
    GtkWidget *add_to_elist(string s, EntryList *elist);
    gboolean samestrings(list<string> &list, EntryList *elist);
    void createstringlist(EntryList *elist, list<string> &alist);    // creates a new string list
    static gboolean string_found(EntryList *elist);                 // Return TRUE if there is a string
  
private:
    void free_witems(void);        
    static void append_empty(GtkWidget *widget, EntryList *elist);
    static void pre_insert(GtkWidget *widget, EntryList *elist);
    static void post_insert(GtkWidget *widget, EntryList *elist);
    static void deleteline(GtkWidget *widget, EntryList *elist);
    static void entry_changed(GtkWidget *widget, Witem *item);
    static void in_here(GtkWidget *widget,
                            GdkEvent *event,
                            GtkWidget **focus_widget);
    static void insertline(GtkWidget *widget, EntryList *elist, gboolean post_insert);
      
    list<Witem *> witems;    // entry widgets and their strings (pointers)
    GtkWidget *focus_widget; // widget with focus
    GtkWidget *box;          // list entry box
        

//    static GdkColor red;
//    static GdkColor blue;
//    static GdkColor green;
//    static GdkColor yellow;
//    static GdkColor purple;
//    static GdkColor orange;
//    static GdkColor cyan;
//    static GdkColor black;
//    static GdkColor white;
//    static GtkStyle *style;     // Highlighted style for focal listed entry widget
//    static GtkStyle *old_style; // Pre-existing style of focal listed entry widget

  
protected:


};    

    
#endif  // End of _ENTRYLIST_H
