/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    RevHead                                                   *
*Project Version: 4.3.0                                                     *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Tuesday 16th April 2013                                   *
*                                                                           *
*Start DateStamp: 15-Sep-2008 11.16.15 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:  http://balean.net/linprogs                                          *
*                                                                           *
*Project Summary:                                                           *
* Create/maintain programming file revision headers and history             *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       header.h                                                  *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       19-Feb-2009 22.13.36 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Header file for header.cpp                                                *
* 20-Aug-2004 12.10.29 -36000 0.00    DMB                                   *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef __HEADER_H__
#define __HEADER_H__


#include "revhead.h"


using namespace std;

class Header
{
public:
  Header(RevHead *revhead);
  ~Header(void);
        
  gboolean write_uf_string(fstream *ofp, string &s, int type);

  gboolean write_RHEnd(fstream *ofp, int type);
  gboolean write2EOL(fstream *ofp, string &s, int type);
   
  static string &get_in_separator(string &s, int type);

  gboolean write_start_separator(fstream *ofp, int type);
  gboolean write_in_separator(fstream *ofp, int type);
  gboolean write_end_separator(fstream *ofp, int type);
        
  gboolean write_slist(fstream *ofp, list<string> list, int type);
  gboolean write_source_directories(fstream *ofp, int type);

  gboolean write_spaces(fstream *ofp, int type);
  gboolean write_PName(fstream *ofp, int type);
  gboolean write_POwner(fstream *ofp, int type);
  gboolean write_PDate(fstream *ofp, int type);
  gboolean write_PVersion(fstream *ofp, int type);

/*
  gboolean write_file_info(fstream *ofp,
                                string *fname,
                                string *major_version,
                                string *minor_version,
                                string *micro_version,
                                string *fauthor,
                                string *fauthor_email,
                                time_t *datestamp,
                                time_t *timezone,
                                int    *daylight,
                                list<string>  *summary,
                                int    type );
*/

  gboolean write_file_info(fstream *ofp, class Files *f, int type);
                                          
  gboolean write_Project(fstream *ofp, int type, string &options, bool changelog);
  gboolean write_Project(fstream *ofp, int type, string &options);
        
  static const string start_comment_start[NUM_TYPES];
  static const string start_comment_end[NUM_TYPES];
  static const string in_comment_start[NUM_TYPES];
  static const string in_comment_key_start[NUM_TYPES];
  static const string in_comment_end[NUM_TYPES];
  static const string end_comment_start[NUM_TYPES];
  static const string end_comment_end[NUM_TYPES];
  static const string comment_separator[NUM_TYPES];


  static const string AuthorTXT;

private:        
  static const string Project_DetailsTXT;
  static const string UnderLineTXT;

  RevHead *rh;

protected:
        
};
       
#endif  // __HEADER_H__
