/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    RevHead                                                   *
*Project Version: 4.3.0                                                     *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Tuesday 16th April 2013                                   *
*                                                                           *
*Start DateStamp: 15-Sep-2008 11.16.15 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:  http://balean.net/linprogs                                          *
*                                                                           *
*Project Summary:                                                           *
* Create/maintain programming file revision headers and history             *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       misc.h                                                    *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       15-Apr-2013 16.37.57 -36000 0                             *
*                                                                           *
*File Summary:                                                              *
* Header file for misc.cpp                                                  *
* 20-Aug-2004 12.10.29 -36000 0.00    DMB                                   *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef _MISC_H
#define _MISC_H


#include "revhead.h"

using namespace std;

namespace misc

{
gboolean isfile(const char *pathname);
gboolean isreadable_file(const char *pathname);
gboolean isdir(const char *pathname);
    
void get_filelist(char *directory, gboolean fileflag, list<string> &alist, RevHead *rh);
bool isseparator(char x);
void getright(string &s, string &v);
bool getline(fstream &ifp, string &line, bool clear_leadin);
bool getvalue(string &line, string &name, string &value);
bool getvalue(fstream &ifp, string &line, string &startname, string &endname, list<string> &value);

void free_list(GList *list);

void remove_leading(string &s);
void remove_trailing(string &s);
void remove_tail(string &s, string &tail);
void remove_head_and_tail(string &s, string &head,string &tail);

string s_toupper(string s);
string s_tolower(string s);

void s_tolower(string *s);
void s_toupper(string *s);



//GtkStyle *CreateStyle(GdkColor fg, GdkColor text, GdkColor bg);
GtkWidget *CreateCheckBox (GtkWidget *box, char *label);

GtkWidget *CreateButton(GtkWidget *box, const char *string);
void decorate_widget(GtkWidget *widget, GdkRGBA *fg_normal, GdkRGBA *bg_normal, GdkRGBA *fg_prelight, GdkRGBA *bg_prelight, const gchar *stock_id);

void SetComboTextList(GtkWidget *combo, GList *list);
GtkWidget *CreateCombobox(GList *list);
GtkWidget *add_page(GtkWidget *notebook, gchar *title);
  
int suficmp(const char *string, const char *suffix);
int sufcmp(const char *string, const char *suffix);

int STREQ(const char *x, const char *y);
int STRIEQ(const char *x, const char *y);
int STREQN(const char *x, const char *y, int n);
int STRIEQN(const char *x, const char *y, int n);
int SUFEQ(const char *x, const char *y);
int SUFIEQ(const char *x, const char *y);

static string case_str;

static string P_NameTXT               = "PROJECT_Name";
static string P_VersionTXT            = "PROJECT_Version";
static string P_OwnerTXT              = "Copyright_Owner";
static string P_EmailTXT              = "PROJECT_Email";
static string Start_SummaryTXT        = "START_Summary";
static string End_SummaryTXT          = "END_Summary";
static string P_StartedTXT            = "DATE_Started";

static string Start_ContactTXT        = "START_Contact";
static string End_ContactTXT          = "END_Contact";
static string Start_CopyrightTXT      = "START_Copyright";
static string End_CopyrightTXT        = "END_Copyright";
static string Start_V_FilesTXT        = "START_Versioned_Files";
static string End_V_FilesTXT          = "END_Versioned_Files";
static string Start_No_Auto_FilesTXT  = "START_No_Auto_Files";
static string End_No_Auto_FilesTXT    = "END_No_Auto_Files";
static string Start_SourcesTXT        = "START_Sources";
static string End_SourcesTXT          = "END_Sources";
static string Changelog_PathTXT       = "CHANGELOG_Path";
static string Changelog_NameTXT       = "CHANGELOG_Name";
static string Start_ChangelogTXT      = "START_Changelog";
static string End_ChangelogTXT        = "END_Changelog";

static string C_Version_PathTXT       = "C_Version_Path";
static string ADA_Version_PathTXT     = "ADA_Version_Path";
static string PHP_Version_PathTXT     = "PHPC_Version_Path";
static string JAVA_Version_PathTXT    = "JAVA_Version_Path";
static string PERL_Version_PathTXT    = "PERL_Version_Path";
static string FORTRAN_Version_PathTXT = "FORTRAN_Version_Path";


// Some colours - probably most not used

static GdkRGBA  red        = { 1.000, 0.000, 0.000, 1.000 };
static GdkRGBA  white      = { 1.000, 1.000, 1.000, 1.000 };
static GdkRGBA  blue       = { 0.000, 0.000, 1.000, 1.000 };
static GdkRGBA  black      = { 0.000, 0.000, 0.000, 1.000 };
static GdkRGBA  yellow     = { 1.000, 1.000, 0.000, 1.000 };
static GdkRGBA  orange     = { 1.000, 0.600, 0.000, 1.000 };
static GdkRGBA  cyan       = { 0.650, 1.000, 1.000, 1.000 };
static GdkRGBA  grey       = { 0.500, 0.500, 0.600, 1.000 };


static GdkRGBA  lightblue  = { 0.300, 0.600, 1.000, 1.000 };
static GdkRGBA  lightgreen = { 0.600, 1.000, 0.300, 1.000 };
static GdkRGBA  lightbrown = { 0.800, 0.600, 0.400, 1.000 };
static GdkRGBA  lightcyan  = { 0.750, 1.000, 1.000, 1.000 };
static GdkRGBA  lightpink  = { 1.000, 0.900, 1.000, 1.000 };

static GdkRGBA pink        = { 1.000, 0.600, 1.000, 1.000 };
static GdkRGBA lightgrey   = { 0.700, 0.700, 0.800, 1.000 };


};


#endif // _MISC_H
