/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    RevHead                                                   *
*Project Version: 4.3.0                                                     *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Tuesday 16th April 2013                                   *
*                                                                           *
*Start DateStamp: 15-Sep-2008 11.16.15 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:  http://balean.net/linprogs                                          *
*                                                                           *
*Project Summary:                                                           *
* Create/maintain programming file revision headers and history             *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       revhead.h                                                 *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       05-Apr-2013 13.58.00 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* Our structure definitions.                                                *
* 06-May-1992 22.17.30.03  0.00    David M. Balean                          *
* 03-Jul-1992 21.30.15.27  0.01    David M. Balean                          *
* Extra member added to struct RevHead, straight or zero-terminated string. *
* 20-Jul-1992 21.36.20.39  0.02    David M. Balean                          *
* Changed project flags to bit fields.                                      *
* Added z_changed and oldstraightflag.                                      *
* 15-Oct-1993 18.13.47.42  2.00    David M. Balean                          *
* Adding to allow for C, BASIC and Modula 2 as well as assembly language.   *
* 14-Jun-1994 11.54.56.01  2.1     David M. Balean                          *
* Removed Modula-2 references as it is not supported.                       *
* 16-Jun-1994 23.45.46.19  2.4     David M. Balean                          *
* Modified to allow for Touch and FixDate.                                  *
* DOS operations use long word aligned variables...                         *
* 28-Jul-1994 20.39.40.12  2.5     David M. Balean                          *
* Not all references to Modula-2 were removed!                              *
* 08-Oct-1994 23.33.07.03  2.6     David M. Balean                          *
* Very slight changes to use a log file in place of error file.             *
* 18-Dec-1994 22.44.44.17  2.7     David M. Balean                          *
* Changed the order of XGadgets in their array.                             *
* 12-Mar-1995 22.45.00.03  2.8     David M. Balean                          *
* Added res2 to the RevHead structure so that sendpkt() can return what     *
* is normally placed in IoErr().                                            *
* 13-Mar-1995 18.46.00.26  2.9     David M. Balean                          *
* Added thisproc and olderrorwindow to the RevHead structure to keep track  *
* of the DOS error window.                                                  *
* 13-Mar-1995 18.46.00.26  2.9     David M. Balean                          *
* Added thisproc and olderrorwindow to the RevHead structure to keep track  *
* of the DOS error window.                                                  *
* 22-Mar-1995 20.15.04.34  3.0     David M. Balean                          *
* Added a field to the revhead structure to take the temporary logfilename. *
* 24-Mar-1995 23.51.17.47  3.1     David M. Balean                          *
* This now includes most of the other  header files as well as              *
* structure definitions etc.                                                *
* 26-Mar-1995 10.39.46.11  3.2     David M. Balean                          *
* Added tname to the files structure for it's copy's temporary name.        *
* 26-Mar-1995 21.07.45.18  3.3     David M. Balean                          *
* Minor changes to accomodate the temporary files but this doesn't affect   *
* the overall size of the RevHead structure because it is only a matter     *
* of changing the names.                                                    *
* 28-Mar-1995 20.18.44.27  3.4     David M. Balean                          *
* A lot of small changes/additions to RevHead structure to allow C++ and    *
* alteration of default tools.                                              *
* 30-Mar-1995 19.59.47.07  3.5     David M. Balean                          *
* Removed f_changed from RevHead structure and put it in Files structure.   *
* This way unchanged files can be saved in the Files structure and at       *
* a later time their headers and dates corrected.                           *
* 19-Dec-1995 22.13.52.07  3.6     David M. Balean                          *
* Added more elements to the RevHead structure to cover change to different *
* directory.                                                                *
* 23-Dec-1995 18.16.37.29  3.7     David M. Balean                          *
* Minor alterations only.                                                   *
* 23-Dec-1995 18.16.37 0  3.7     David M. Balean                           *
* The definitions for RevHead and others                                    *
* 23-Dec-1995 18.16.37 0  3.8     David M. Balean                           *
* Minor changes                                                             *
* 23-Dec-1995 18.16.37 0  3.9     David M. Balean                           *
* Changed definition of RH_DEFAULTS                                         *
* 23-Dec-1995 18.16.37 0  3.10    David M. Balean                           *
* Added extra flags to the RevHead struct for incrementing versions         *
* 23-Dec-1995 18.16.37 0  3.11    David M. Balean                           *
* 20-Aug-2004 12.10.29 -36000 3.15    David M. Balean                       *
* Main header file, several things deleted or moved elsewhere               *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/


#ifndef __REVHEAD_H__
#define __REVHEAD_H__



#include <gtk/gtk.h>

#include <string>
#include <iostream>
#include <fstream>

#include <cerrno>

#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>

#include <wait.h>

#include <unistd.h>
#include <stdlib.h>

#include <ctime>

#include <utime.h>
#include <dirent.h>

#include <list>

#include "changedir.h"
#include "logfile.h"
#include "quit.h"
#include "about.h"

using namespace std;

#define UNLESS(x) if(!(x))
#define FOREVER for(;;)
#define UNTIL(x) while(!(x))


// General purpose enum...
// Type of current file type, line length, path size
enum {  NO_TYPE = -1,
        C_TYPE,
        CPP_TYPE,
        ADA_TYPE,
        PHP_TYPE,
        JAVA_TYPE,
        PERL_TYPE,
        FORTRAN_TYPE,
        HASH_TYPE,
        CPP2_TYPE,
        NUM_TYPES,
        LINE_LENGTH=75 };


enum { TOUCH, FIXDATE };


/*
 RevHead Errors
 --------------

There is the usual problem of deciding on the best method for managing errors.
They can be output to a file e.g. RH_Errors, or sent to a window e.g. stderr,
or sent to the RevHead window itself.  Whichever is used, the user should be
informed if an error or errors occur and the precise nature of the error(s).
The information should include:
	1) a text describing the error
	2) the name of the file in which the error occurred
	3) if another file was involved, the name of that file also

	The error text can be offset from an array of zero terminated strings
using an index.

This should be an enum....
*/


enum {
// NON-ERRORS
        NO_ERR,                       // 0
        USER_ABORT_ERR,               // 1

// WARNINGS
        CREATE_ICON_WARN,             // 2 Icon not created
        NO_OPEN_WARN,                 // 3 Log file only
        NO_DELETE_WARN,               // 4
        TOUCH_WARN,                   // 5
        FIXDATE_WARN,                 // 6
        RH_WARNING = FIXDATE_WARN,    // 6

// ERRORS - Supposedly recoverable
        DS_ERROR,                     // 7
        VERSION_ERROR,                // 8
        FILENOTE_ERROR,               // 9
        COPY_FILENOTE_ERROR,          // 10

// FATAL ERRORS
        RH_FATAL_ERROR,               // 11
        TIME_F_ERR = RH_FATAL_ERROR,  // 11
        MEMORY_F_ERR,                 // 12
        WINDOW_F_ERR,                 // 13
        WORKBENCH_F_ERR,              // 14
        ICON_F_ERR,                   // 15
        ARG_TWICE_F_ERR,              // 16
        MISSING_ARG_F_ERR,            // 17
        PATHLOCK_F_ERR,               // 18
        PROGPATH_F_ERR,               // 19
        TEMP_OPEN_F_ERR,              // 20
        PATH_F_ERR,                   // 21
        RENAME_F_ERR,                 // 22
        OPEN_F_ERR,                   // 23
        READ_F_ERR,                   // 24
        WRITE_F_ERR,                  // 25
        UNDERSTAND_F_ERR,             // 26
        TOO_MANY_ERR,                 // 27
        
        EXAMINE_F_ERR,                // 28
        READDIR_F_ERR,                // 29
        CLOSEDIR_F_ERR,               // 30
        ACCESS_F_ERR,                 // 31
        PROJ_UPDATE_F_ERR,            // 32
        SEEK_F_ERR,                   // 33
        LOG_F_ERR,                    // 34
        COPY_F_ERR,                   // 35
        READWRITE_F_ERR,              // 36
        CREATEFILE_F_ERR,             // 37
        FILE_UPDATE_F_ERR,            // 38
        FILECHANGES_F_ERR,            // 39
        UNKNOWN_ERR,                  // 40
        NUMBER_OF_ERRORS,             // 41
        MAX_ERRORS = 100 };





class Files
{
public:
  time_t datestamp;      // Datestamp of this file
  time_t timezone;       // time Zone difference of this file
  int    daylight;       // seconds of daylight saving, I don't think it can be negative...

  string name;		       // name of this file
  string pathname;       // full pathname of this file
  string major_version;  // version if wanted else empty
  string minor_version;  // version if wanted else empty
  string micro_version;  // version if wanted else empty


  string author;
  string author_email;
  int comment_type;      // if logged, this is its comment type
  list<string>  comment;
  list<string>  summary;


  struct
    {

// 1 if file header to be changed and file re-written, 0 if not logged
    unsigned logged	: 1;

// 0 if file details unchanged, do header only and/or using fixdate
    unsigned changed	: 1;

// 1 if this file requires a version 
    unsigned version_wanted : 1;

// 1 if no auto-inc for this file version
    unsigned no_auto_inc : 1;

// 1 if file summary has been changed
    unsigned newsummary	: 1;

    } flags;
};


class RevHead
{
public:
  RevHead(int numargs, char **args, class Quit *qt);
  ~RevHead(void);
        
  static void DoDestroyWidget(GtkWidget *widget, RevHead *rh);
  void DestroyWidgets(void);
  void init_flags_and_data(void);
  string get_project_name_and_version(void);
  void get_version(string &buffer, string &major, string &minor, string &micro);
  void append_version(string &buffer, string major, string minor, string micro);
  int find_string(fstream &ifp, string &test_str, string &buffer); // 1=FOUND 0=FAILED, -1=END_OF_HEADER
  gboolean read_line(fstream &ifp, string &buffer);
        
  gboolean write_string(fstream &ofp, string &buffer);

  int get_file_type(string filename, gboolean flag);
  gboolean is_logged(string &fname, int &comment_type);

  void FrontPanel(void);
        
  static void QuitFunc(GtkWidget *widget, class Complain *cn);
  static void CloseAppWindow (GtkWidget *widget, gpointer data);
  static void CallButton(GtkWidget *widget, int data);
  static class Quit *quit;

  static string RH_Start;
  static string RH_End;
  static string PathTXT;
  static string UpdateProjectTXT;
  static string NoUpdateTXT;
  static string NoLogTXT;
  static string P_OwnerTXT;         
  static string P_EmailTXT;

  static string P_NameTXT;
  static string P_CopyrightTXT;
  static string ContactTXT;        
  static string P_DateTXT;
  static string P_Start_VersionTXT;
  static string P_VersionTXT;
  static string Start_DSTXT;
  static string P_SummaryTXT;
  static string CommentsTXT;
  
  static string F_ThisFileTXT;
  static string F_SummaryTXT;
  static string F_VersionTXT;
  static string AuthorTXT;
  static string AuthorEmailTXT;
  static string P_EnvironmentTXT;
  static string DefaultsTXT;
  static string NewProjectTXT;
  static string SourceDirsTXT;
  static string ChangeLogDirTXT;
  static string OKTXT;
  static string QuitAllTXT;
  static string CancelTXT;
        
  static GdkPixbuf *icon_pixbuf;
  
  class Logfile *logfile;     // There should only be one instance of this
        
  time_t  p_startds;          // Datestamp when project started
  time_t  p_starttz;          // Time Zone difference at start
  int     p_start_daylight;   // Daylight saving in seconds at start
  time_t  p_currentds;        // Now
  time_t  p_currenttz;        // Time Zone difference now
  int     p_current_daylight; // Current daylight saving in seconds
  string  datebuffer;

  class Defaults      *nd;
  class Fixfiles      *ff;  
  class Update        *ud;
  class Environment   *ev;        
  class ChangeDir     *cd;       
  class About         *ab;
 
  static int     argc;        // copy of argc
  static char    **argv;      // copy of argv
  static string progname;     // Full pathname of revhead itself
        
  list<Files> file_list;
        

  static GtkWidget *window;   // RevHead's window
  static gint width;          // RevHead's window start width
  static gint height;         // RevHead's window start height
  static GtkWidget *menu;     // Popup menu

  GtkWidget   *vbox;          // RevHead's container
  GtkWidget   *status;        // RevHead's status
  GtkWidget   *title;         // Title of this panel

  string project_path;        // Path of the project
  static string path;         // The CURRENT path (e.g. source directories)
  list<string> source_path;   // List of source paths to be processed
  string changelog_path;      // If not empty, ChangeLog wanted
  string changelog_name;      // Normally "ChangeLog"
  list<string> changelog;     // The current changelog from environment
  list<string> version_files; // Source files requiring file version
  list<string> no_auto_files; // Source files requiring file version but not to be auto-incremented

  DIR     *dp;                // Directory pointer
  struct  dirent  *direntry;  // This directory entry

  int    numerrs;             // Number of errors
  int    rc;                  // RevHead's return code
        
// Extracted from .revhead.defs, or NULL if file not found
  string np_owner;            // default copyright owner
  string np_owner_email;      // copyright owner's default email address
  string np_major_version;    // default version [8  =  7 + 0]
  string np_minor_version;
  string np_micro_version;
  list<string>  np_copyright; // start of default copyright [51 = 50 + 0]
  list<string>  np_address;   // start of default address   [74 = 73 + 0]
  string nf_author;           // default file author    [51 = 50 + 0]
  string nf_author_email;     // default file author's email address
  string nf_major_version;    // default version [8  =  7 + 0]
  string nf_minor_version;
  string nf_micro_version;

  string p_name;              // Project Name           [31 = 30 + 0]
  string p_major_version;     // Project Version        [8  =  7 + 0]
  string p_minor_version;
  string p_micro_version;

  string p_name_and_version;

  string p_owner;             // copyright owner string
  string p_owner_email;       // copyright owner's email address
  list<string>  p_copyright;  // Project Copyright      [51 = 50 + 0]
  list<string>  p_address;    // Project Contact Address[74 chars each, 73 + 0]
  list<string>  p_comment;    // Project Comment        [74 chars each, 73 + 0]
  list<string>  p_summary;    // Project Summary

// Paths for version files if not empty
// If empty, default is first path matching source type
// OR project directory if none matches.
  string c_version_path;
  string ada_version_path;
  string php_version_path;
  string java_version_path;
  string perl_version_path;
  string fortran_version_path;


  struct
    {
    unsigned rh_starting          : 1;  // 1 if revhead is starting
    unsigned environment_required : 1;  // 1 if environment is required
    
    unsigned newproject	          : 1;  // 1 if new project (no ".revhead.project")
    unsigned newname              : 1;  // 1 if project name changed

    unsigned new_major_version	  : 1;  // 1 if version changed
    unsigned new_minor_version	  : 1;  // 1 if version changed
    unsigned new_micro_version	  : 1;  // 1 if version changed

    unsigned newowner             : 1;  // 1 if copyright owner changed
    unsigned newemail             : 1;  // 1 if project email changed
    unsigned newcopyright         : 1;  // 1 if copyright changed
    unsigned newaddress	          : 1;  // 1 if address changed
    unsigned newsummary           : 1;  // 1 if summary changed
    unsigned p_changed            : 1;  // 1 if any of above = 1
    unsigned pc_changed	          : 1;  // 1 if comment

    unsigned want_log             : 1;  // 1 if log file required
    unsigned append_log           : 1;  // 1 if new log appended to old
    unsigned log_to_cerr          : 1;  // 1 if log to be sent also to cerr 
      
    unsigned c_file               : 1;  // 1 if C to be processed
    unsigned cpp_file             : 1;  // 1 if C++ to be processed
    unsigned cpp_t                : 1;  // 1 if CPP type comments with CPP
    unsigned cpp2_t               : 1;  // 1 if CPP 2 type comments with CPP
    
    unsigned c_v                  : 1;  // 1 if C or CPP version file required

    unsigned ada_file             : 1;  // 1 if ADA to be processed
    unsigned ada_v                : 1;  // 1 if ADA version file required

    unsigned php_file             : 1;  // 1 if PHP to be processed
    unsigned php_c_t              : 1;  // 1 if PHP C type comments
    unsigned php_cpp_t            : 1;  // 1 if PHP CPP 1 type comments
    unsigned php_cpp2_t           : 1;  // 1 if PHP CPP 2 type comments
    unsigned php_h_t              : 1;  // 1 if PHP # type comments
    unsigned php_v                : 1;  // 1 if PHP version file required

    unsigned java_file            : 1;  // 1 if JAVA to be processed
    unsigned java_c_t             : 1;  // 1 if JAVA C type comments
    unsigned java_cpp_t           : 1;  // 1 if JAVA CPP 1 type comments
    unsigned java_cpp2_t          : 1;  // 1 if JAVA CPP 2 type comments
    unsigned java_v               : 1;  // 1 if JAVA version file required

    unsigned perl_file            : 1;  // 1 if PERL to be processed
    unsigned perl_v               : 1;  // 1 if PERL version file required

    unsigned fortran_file         : 1;  // 1 if FORTRAN to be processed
    unsigned fortran_v            : 1;  // 1 if FORTRAN version file required

    unsigned p_want_micro         : 1;  // 1 if micro project version required
    unsigned p_auto_inc           : 1;  // 1 if auto increment project versions

    unsigned f_auto_inc           : 1;  // 1 if auto increment file versions

    unsigned np_want_micro        : 1;  // 1 if default want micro version
    unsigned np_auto_inc          : 1;  // 1 if default auto increment project version

    unsigned nf_auto_inc          : 1;  // 1 if default auto increment file versions

    unsigned abort                : 1;  // 1 if fatal error or "abort"
    } flags;
  

private:
  static void callback_new_defs(GtkWidget *widget, RevHead *rh);
  static void callback_update(GtkWidget *widget, RevHead *rh);
  static void callback_touch(GtkWidget *widget, RevHead *rh);
  static void callback_fixdate(GtkWidget *widget, RevHead *rh);
  static void callback_env(GtkWidget *widget, RevHead *rh);
  static void callback_change_directory(GtkWidget *widget, RevHead *rh);
  static void callback_cancel(GtkWidget *widget, RevHead *rh);
  static void callback_about(GtkWidget *widget, RevHead *rh);

  static gint callback_menu(GtkWidget *widget, GdkEventButton *event, RevHead *rh);  
  void destroy_menu(RevHead *rh);
  void create_menu(RevHead *rh);
  void read_env(void);                // If these need to be called from elsewhere, add "rh" ?
  void fix_dir_change(char *newdir);
  void get_current_pathname(void);
  gboolean get_pathname_from_path(char *fname, char *pathname);
  void get_prog_pathname(void);

//  GtkTooltips *tooltips;

  static const guint8 rh_pixbuf_source[];
  static gulong menu_id;

protected:
        
};



#endif  // __REVHEAD_H__
/* END OF FILE */
