/****************************************************************************
*RevHead_Start                                                              *
*                                                                           *
* Project Details                                                           *
* ---------------                                                           *
*Project Name:    RevHead                                                   *
*Project Version: 4.3.0                                                     *
*Copyright Owner: David M. Balean <linprogs@balean.net>                     *
*Copyright Notice:                                                          *
* This program is free software; you can redistribute it and/or modify it   *
* under the terms of the GNU General Public License as published by         *
* the Free Software Foundation, either version 3 of the License or,         *
* (at your option) any later version.                                       *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
* See the GNU General Public License for more details.                      *
* You should have received a copy of the GNU General Public License         *
* along with this program. If not, see <http://www.gnu.org/licenses/>.      *
*                                                                           *
*Project Date:    Tuesday 16th April 2013                                   *
*                                                                           *
*Start DateStamp: 15-Sep-2008 11.16.15 -36000 0                             *
*                                                                           *
*Contact:                                                                   *
* email: linprogs@balean.net                                                *
* snail: D.M. Balean, 44 Wyong Road, Killarney Vale, N.S.W. 2261, AUSTRALIA *
* URL:  http://balean.net/linprogs                                          *
*                                                                           *
*Project Summary:                                                           *
* Create/maintain programming file revision headers and history             *
*                                                                           *
*****************************************************************************
*                                                                           *
*This File:       tfile.h                                                   *
*Author:          David M. Balean <linprogs@balean.net>                     *
*DateStamp:       20-Nov-2008 14.43.45 -36000 3600                          *
*                                                                           *
*File Summary:                                                              *
* FILE:  tfile.h                                                            *
* Header for the temporary file module                                      *
* 04-Jul-1999 09.18.06 -36000  0.00    David M. Balean                      *
* 20-Aug-2004 14.43.24 -36000 0.01    DMB                                   *
* Allowing external access to more functions                                *
*                                                                           *
*RevHead_End                                                                *
****************************************************************************/

#ifndef _TFILE_H
#define _TFILE_H

#include <iostream>
#include <fstream>


using namespace std;

class TFile
{
public:
        TFile(void);
        ~TFile(void);

        string &itoa(int n,  int pad);
        string &itoa(int n);
        int power(int n, int base);
        
        string *tfile(string *pathname, fstream *ofp, int n);
        string *tfile(string *pathname, fstream *ofp);
        int filecopy(string *dname, string *sname);
        int overwritefile(string *dname, string *sname);
                
        string *copy(string *pathname, int n);
        string *copy(string *pathname);
        int do_copy(fstream *ofp, fstream *ifp);
        int append(string *dname, string *sname);

private:        
        int filecopy(string *dname, string *sname, int overwite);        

        string a_val;
        
protected:
 
};
 
#endif // _TFILE_H
